package kz.arta.synergy.workflow.mobile.android.common.offline.add;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.ArrayList;
import java.util.List;

import kz.arta.synergy.workflow.mobile.android.common.models.offline.OfflineRemoveComment;

/**
 * Created by neox on 11.08.14.
 */
public class AddRemoveComment extends SQLiteOpenHelper {

    private SQLiteDatabase db = getWritableDatabase();
    private static final String TABLE_NAME = "RemoveComment";
    private static final String TABLE = "create table " + TABLE_NAME + " ("
            + "actionID text,"
            + "commentID text,"
            + "name text,"
            + "comment_name text"
            + ");";

    public AddRemoveComment(Context context) {
        super(context, TABLE_NAME, null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase sqLiteDatabase) {
        sqLiteDatabase.execSQL(TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int i, int i2) {

    }

    public boolean remove() {
        try {
            db.delete(TABLE_NAME, null, null);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public boolean add(String actionID, String commentID, String name, String commentName) {
        try {
            db.delete(TABLE_NAME, "commentID = ?", new String[]{commentID});
            ContentValues cv = new ContentValues();
            cv.put("actionID", actionID);
            cv.put("commentID", commentID);
            cv.put("name", name);
            cv.put("comment_name", commentName);
            db.insert(TABLE_NAME, null, cv);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public List<OfflineRemoveComment> get() {
        List<OfflineRemoveComment> result = new ArrayList<>();
        Cursor c = null;
        try {
            c = db.query(TABLE_NAME, null, null, null, null, null, null);
            if (c.moveToFirst()) {
                do {
                    OfflineRemoveComment item = new OfflineRemoveComment();
                    item.setActionID(c.getString(c.getColumnIndex("actionID")));
                    item.setCommentID(c.getString(c.getColumnIndex("commentID")));
                    item.setName(c.getString(c.getColumnIndex("name")));
                    item.setCommentName(c.getString(c.getColumnIndex("comment_name")));
                    result.add(item);
                } while (c.moveToNext());
            }
            return result;
        } catch (Exception exc) {
            return result;
        } finally {
            if (c != null) {
                c.close();
            }
        }
    }
}
